	device zxspectrum128
;        ORG #4000
; incbin "atari3.scr"
        ORG #6000
begin
	ld sp,$5FE0
	ld hl,song:call stc_init
	ld hl,picp1,de,$4000:call dzx7_standard
	ld a,$17,bc,$7ffd:out (c),a
	ld hl,picp2,de,$C000:call dzx7_standard
;fill screen
;	ld a,$17,bc,$7ffd:out (c),a
;	ld hl,$D800,de,$D801,bc,767,(hl),4*9:ldir

	ld a,$10,bc,$7ffd:out (c),a
;prepare tables
	ld hl,$C000
	ld ix,bars+15

fo0:
	push hl,ix
	ld b,16
fo1:
	ld d,(ix+0):dec ix
	call doline
	djnz fo1

	ld (hl),$10
	inc h
	ld (hl),1
	dec h

	ld de,hl
	ld b,55
fo2:
	ld a,(de),(hl),a
	inc d,h
	ld a,(de),(hl),a
	dec d,h
	dec e
	inc l
	djnz fo2
;	ld b,7
;fo2:
;	ld d,(ix+0):inc ix
;	call doline
;	djnz fo2
	ld (hl),$10:inc h
	ld (hl),1:dec h
	inc l
	ld (hl),$10:inc h
	ld (hl),1:dec h

	pop ix,hl
	ld de,16
	add ix,de
	inc h,h
	jp nz,fo0
	
;
	di
	ld a,$5F,i,a
	im 2
	ld hl,intvec,($5FFF),hl
	ei

zu:
	ei:halt
	xor a:out ($FE),a
	call scroll
	ld a,1:out ($FE),a
;delay
	ld bc,512
dela:
	dec bc
	ld a,b
	or c
	jp nz,dela
;
tp:	ld hl,$C000
	ld bc,$7FFD
 dup 184
;224 per line
; visible page border
	ld e,(hl) ; 7
	inc h ; 4
	ld a,(hl) ; 7
	dec h ; 4
	inc l ; 4
	out (c),e ; 12
	out ($FE),a ;11

;7+4+7+4+4+11+12=49
;224-49-175
;175=8*20+15
	nop;4
	nop;4
	ld e,0;7
;8*20
	dup 8
	db $ED,$63,0,0;ld(0),hl -fix for sjasmplus
edup

edup
	ld a,1:out ($FE),a
	call stc_play
;	ld a,6:out ($FE),a
	ld a,$10,bc,$7ffd:out (c),a
cc: ld a,0
	inc a
	ld (cc+1),a
	and 31
	add a,a
	or $C0
	ld (tp+2),a
;doscroll
sc: ld a,0
	inc a
	ld (sc+1),a
	and 7
	jp nz,zu
;***************************************
scp:ld hl,scrtxt
	ld a,(hl)
	or a
	jr nz,notlp
	ld hl,scrtxt
	ld a,(hl)
notlp:
	inc hl
	ld (scp+1),hl
	ld h,0,l,a
	ld de,fnt-256
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,de
	ld de,buf
	ld bc,8
	ldir
;***************************************
	jp zu
;-----------------------------------------
screen_adr equ #50ff;screen adress for output
scroll:
 ld hl,screen_adr
 ld ix,buf
 ld b,8
scroll_text:
 push hl
 sla (ix+0)

 dup 32;unroll cycle
 rl(hl)
 dec l
edup

 inc ix
 pop hl
 inc h
 dec b
 jp nz,scroll_text
	ret

;out text, IX: string with limiter 0
;scrp:ld ix,scrtxt
; ld a,(ix)
; or a
; jr nz,noloop
;;if zero loop text again
; ld ix,scrtxt
; ld a,(ix)
;noloop:ld (scrp+2),ix
;
; ld de,screen_adr
; ld l,a,h,0; calculate adress ROM font
; 
; add hl,hl;ascii*8
; add hl,hl
; add hl,hl
; ld bc,fnt-256
; add hl,bc
; ex de,hl
;
;
; ld b,8;one loop for letter
;letrlp:
; ld a,(de)
;bw:and #80
; jr z,nobit
; set 0,(hl)
;nobit:
; inc de,h
; djnz letrlp
;
; ld a,(bw+1)
; or a
; rrca
; ld (bw+1),a
; ret nc
;
; ld hl,(scrp+2)
; inc hl
; ld (scrp+2),hl
; ret
scrtxt:; db "*simple scroll* "
 incbin "scrolly.txt"
 db 0
buf: ds 8
fnt:incbin "Metallion05.fnt"
;-----------------------------------------
bars:incbin "bars16x32.bin"
intvec:
	ei
	ret
doline:
 dup 8
	rr d
	sbc a,a
	push af
	and 8
	or $10
	ld (hl),a
	inc h
	pop af
	and 4
	jr nz,$+4;nobord
	ld a,1
;nobord:
	and 7
	ld (hl),a
	dec h
	inc l
edup
	ret
plyr:include "stc_player.a80"
song:incbin "owolf128.stc"
zx7:include "zx7.a80"
picp1:incbin "atari3.scr.zx7"
picp2:incbin "atari4.scr.zx7"
end

;	page 7
;	org $C000
;page7b:
; incbin "atari4.scr"
;page7e:

	display end
	display /d,end-begin
	savesna "!void.sna",begin

;-----------------------------------------------------------
 macro	sectors datab,datae

 IF low (datae-datab)=0
   db 1,5,high (datae-datab)
 ELSE
   db 1,5,(1+high (datae-datab))
 ENDIF

	endm

 MODULE boot
Basic:
 db #00,#01; 
 DW EndLine1 - Line1
Line1:
 db #EA;REM
 ld sp,#5FFE

    res 4,(iy+1)
    xor a:out ($FE),a
    ld hl,$5AFF,de,$5AFe,bc,$1B00-1,(hl),0:lddr

;demo
 di
 ld de,(#5CF4)
 ld hl, #6000
 ld a,#10,bc,#7FFD:out (c),a
 sectors begin,end
 call #3d13

 jp #6000


 db "nyuk cocksucker"
 db #0D
EndLine1:
 db #00,#02
 DW EndLine2 - Line2
Line2:
 db #20,#FD,#B0
 db #22,#32,#34,#35,#37,#35,#22;clear val "24575"
 db #3A; :
 db #F9,#C0,#28,#35;randomize usr (5+256*peek val "23635"+peek val "23636"
 db #0E,#00,#00,#05,#00,#00,#2B
 db #32,#35,#36
 db #0E,#00,#00,#00,#01,#00,#2A,#BE

 db #B0
 db #22,#32,#33,#36,#33,#36,#22;"23635"
 db #2B;???
 db #BE
 db #B0
 db #22,#32,#33,#36,#33,#35,#22;"23636"
 db #29,#0D;)
 db #80
 db #AA,1,0;;;;;;;;;;;;;autorun line,change program length to -4, e.g. 83-4=79
EndLine2:
EndBasic:
 ENDMODULE

    EMPTYTRD "dust.trd" ;create empty TRD image
	SAVETRD "dust.trd", "boot.B", boot.Basic, boot.EndBasic - boot.Basic
    SAVETRD "dust.trd","demo.C",begin,end-begin
;-----------------------------------------------------------
